/*
 * Event.java
 *
 * Created on 2 dcembre 2004, 18:03
 */

package metacalendrier;
import java.util.*; 
import java.text.SimpleDateFormat;
/**
 * Objet "evenement"
 * <br/>Objet utilis dans la plupart du program en interagant
 * <br/>Tous attributs sont accessibles en set/get
 *
 * @author hainam
 */
public class Event {
    private int id;
    private String url;
    private Date timeWrap;
    private Date dateBegin;
    private Date dateEnd;
    private String place;
    private String country;
    private String title;
    private String detail;
    
    /**
     * Creer une nouvelle instance de Event, sans parametres initiaux
     */
    public Event() {
    }

    /**
     * Creer une nouvelle instance de Event, avec parametres initiaux
     */
    public Event(int id, String url, Date timeWrap, Date dateBegin, Date dateEnd, String place, String country, String title, String detail){
        this.id = id;
        this.url = url;
        this.timeWrap = timeWrap;
        this.dateBegin = dateBegin;
        this.dateEnd = dateEnd;
        this.place = place;
        this.country = country;
        this.title = title;
        this.detail = detail;
    }
    
    public int getId(){
        return id;
    }

    public void setId(int id){
        this.id = id;
    }

    public String getUrl(){
        return url;
    }

    public void setUrl(String url){
        this.url = url;
    }

    public Date getTimeWrap(){
        return timeWrap;
    }

    public void setTimeWrap(Date timeWrap){
        this.timeWrap = timeWrap;
    }

    public String getPlace(){
        return place;
    }

    public void setPlace(String place){
        this.place = place;
    }

    public String getCountry(){
        return country;
    }

    public void setCountry(String country){
        this.country = country;
    }

    public String getTitle(){
        return title;
    }
    public void setTitle(String title){
        this.title = title;
    }

    public String getDetail(){
        return detail;
    }
    
    public void setDetail(String detail){
        this.detail = detail;
    }

    public Date getDateBegin(){
        return dateBegin;
    }
    
    public void setDateBegin(Date dateBegin){
        this.dateBegin = dateBegin;
    }

    public Date getDateEnd(){
        return dateEnd;
    }
    
    public void setDateEnd(Date dateEnd){
        this.dateEnd = dateEnd;
    }
    
    public String toString(){
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yy");
        return "[==> Evenement <"+id+"> \nreu de [URL:"+url+"]  "+sdf.format(timeWrap)+" avec date ["+dateBegin+" - "+dateEnd+"]  "+place+", "+country+"\n"+title+"\nDetail: "+detail+"\n\n";
    }
}
