/*
 * Extractor.java
 *
 * Created on 17 novembre 2004, 02:33
 */

package metacalendrier;

import java.io.*;
import java.net.URL;

import roadrunner.*;
import roadrunner.util.Indenter;
import roadrunner.util.DOMLoader;
import roadrunner.ast.Expression;
import roadrunner.ast.ASTEncoder;
import roadrunner.ast.ASTDecoder;
import roadrunner.parser.BindingException;
import roadrunner.config.Config;
import roadrunner.config.Preferences;
import roadrunner.marshall.InstanceSerializer;

/**
 * Extraire des evenement  partir d'un site web et un wrappeur accompagn
 * @author Hai Nam
 */
public class Extractor {
    
    private String wrapper;
    private String url;
    private String output;

    /**
     * Creates a new instance of Extractor
     */
    public Extractor(String wrapper, String url, String output) {
        this.output = output;
        this.wrapper = wrapper;
        this.url = url;
    }
    
    /**
     * Creates a new instance of Extractor
     */
    public Extractor(String wrapper, String url) {
        this(wrapper, url, Main.homePath()+"/output/events.xml");
    }
    
    public void parse(){
        Wrapper w = null;

        try {
            w = Wrapper.load(new File(wrapper));
        }
        catch (Exception e) {
            System.err.println("Cannot decode wrapper from xml "+e);
            System.exit(-1);
        }
        
        try {
            Sample sample = new Sample(new URL(url), w.getPrefs());
            Instance data = w.wrap(sample);
            FileWriter out = new FileWriter(output);
            out.write("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
            new InstanceSerializer(data,out,new Indenter()).encode();
            out.close();
        }
        catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }
    
    public String getUrl(){
        return url;
    }
    
}
