/*
 * Refiner.java
 *
 * Created on 17 novembre 2004, 02:34
 */

package metacalendrier;

import java.io.*;
import java.net.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import java.sql.*;

/**
 * Chercher les doublons/annuls
 * @author  Benj
 */
public class Refiner {
    
    private SQL sql;
    private static boolean debug=false;

    /** Creates a new instance of Refiner */
    public Refiner(SQL sql) {
        this.sql = sql;
    }
    
    /** 
     * Lancer le Refiner !!! 
     * La recherche s'effectue sur le titre seulement
     * faut encore verifier autre donnes: date/lieu/infos detailles
    */
    public void run() {
        ArrayList events = new ArrayList();
        ResultSet rs=null;
        Statement stmt = null;

        try{
            stmt = sql.getConn().createStatement();
        } catch( Exception ex ){
            ex.printStackTrace();
        }
         
        /**
         * Lire tous vnements
         */
        try{
            rs = stmt.executeQuery("SELECT * FROM " + sql.tblRawEvents + " ORDER BY dateBegin");
            while (rs.next()) {
                events.add(sql.readEvent(rs));
            }
            stmt.execute("DELETE FROM " + sql.tblEvents);
        } catch( Exception ex ){
            ex.printStackTrace();
        }

        try {
            Iterator i = events.iterator();
            
            while (i.hasNext())
            {
                Event e = (Event)i.next();
                Event e2 = null;
                Iterator j = events.iterator();
                /** evnement juste aprs e */
                while (j.next()!=e) {}
                
                boolean found = false;
                while (!found && j.hasNext()){
                    e2 = (Event)j.next();

                    /** 
                     * true si les deux phrases sont en dessous du seuil 1 
                     * (il reste toujours des fautes negatives...)
                     *
                     * quand le titre d'evenement est plus long/detaille, on pourrait l'augment  2 ou 3...
                     * faut encore verifier autre donnes: date/lieu/infos detailles
                     */
                    if (comparaisonDeuxPhrase(e.getTitle(), e2.getTitle(), 1)) {
                        found=true;
                        System.out.println("Trouv: ID="+e.getId()+" et ID="+e2.getId());
                    }
                }
                
                if (!found){
                    /** inserer Evenement dans le tableau principal */
                    sql.insertEvent(e);
                }
            }
        }catch (Exception ex) {System.out.println("EXCEPTION:" + ex);}
        
    }
    
    /** minimum de trois entiers */
    private static int minimum(int a, int b, int c) {
        int mi;
        mi = a;
        if (b < mi) {mi = b;}
        if (c < mi) {mi = c;}
        return mi;
    }
    
    /** Compteur de  Levenshtein de distance */
    public static int LD(String s, String t) {
        int d[][]; // matrice
        int n,m; // longuers de s et t
        int i;
        int j;
        char s_i;
        char t_j;
        int cost;
        n = s.length();
        m = t.length();
        if (n == 0) {
            return m;
        }
        if (m == 0) {
            return n;
        }
        d = new int[n+1][m+1];
        for (i = 0; i <= n; i++) {
            d[i][0] = i;
        }
        for (j = 0; j <= m; j++) {
            d[0][j] = j;
        }
        for (i = 1; i <= n; i++) {
            s_i = s.charAt(i - 1);
            for (j = 1; j <= m; j++) {
                t_j = t.charAt(j - 1);
                if (s_i == t_j) {cost = 0;} else {cost = 1;}
                d[i][j] = minimum(d[i-1][j]+1, d[i][j-1]+1, d[i-1][j-1] + cost);
            }
        }
        return d[n][m];
    }
    /**
     * Decomposition d'une phrase en mots
     * Return un Vector des mots de la phrase entrer en parametre
     * Dcoupe avec les blancs, les , les . les / les ; les : les ! les ?
     */
    public static Vector detachePhrase(String a){
        a=" "+a+" ";
        char s=a.charAt(0);
        Vector A = new Vector();
        int i=0,n=-1,j=0,k=0;
        while(i<a.length()-1){
            s=a.charAt(i);
            while(s!=',' && s!=' ' && s!='.' && s!='/' && s!=';' && s!='&' && s!=':' && s!='?' && s!='!' && i<a.length()-1){
                n=i+1;
                i++;
                s=a.charAt(i);
            }
            if (i==n){
                A.add(j,a.substring(k+1,i));
                j++;k=i;
            } else {k=i;}
            i++;
        }
        return A;
    }
    
    /**
     * Comparaison de deux phrase 
     * On dfinit une distance entre deux phrases commettant la  somme des Min des
     * distance entre un mots de la 1er et les mots de la 2eme diviser par le
     * Min de nombres de mots dans chaque phrase.
     * Cette fonction prend un entier "n" comme parametre ces lui qui va nous
     * indiquer si les deux phrase sont identique, la fonction return true si
     * la distans est inferieur a n false si non
     */
    public static boolean comparaisonDeuxPhrase(String s, String t, int n)throws IOException {
        Vector S = new Vector();
        Vector T = new Vector();
        Vector A = new Vector();
        S=detachePhrase(s);
        T=detachePhrase(t);
        
        
        S=nettoyageDePhrase(S);
        T=nettoyageDePhrase(T);
        if (debug) {
            System.out.println(S);
            System.out.println(T);
        }
        float max=0;
        if(S.size()>T.size()){A=S;S=T;T=A;}
        for(int i=0;i<S.size();i++){
            int h=1000;
            for(int j=0;j<T.size();j++){
                String a=(String)S.elementAt(i);
                String b=(String)T.elementAt(j);
                if (LD(a,b)<h) h=LD(a,b);
            }
            max=max+h;
        }
        if(S.size()<T.size()){max=max/S.size();} else{max=max/T.size();}
        return (max<n);
    }
    
    
    /**
     *Distance entre un mots et une phrase
     *@return Return un entier que represente le min des distance entre le mot et tout les mots de la phrase
     */
    public static int inStrLev(String s, String t) {
        int d=10000;
        for (int i=0; i-1 < (t.length() - s.length()) ; i++) {
            if ( LD(s, t.substring(i,i+s.length()) )<d ) d = LD(s, t.substring(i,i+s.length() ));
        }
        return d;
    }
    
    /**
     * Nettoyage des phrase de mots inutile commme :de, avec, le..
     * Les mots inutile comme de, avec... qui sont ecrit dans un fichier ... sont
     * enleve par cette fonction qui return un Vector de mots. 
     */
    public static Vector nettoyageDePhrase(Vector s)throws  IOException {
        String fichier=metacalendrier.Main.homePath()+"/motsInutiles.txt";//"c:\\toto.txt"
        BufferedReader in = new BufferedReader( new FileReader(fichier));
        String laChaineLue=in.readLine();
        if (debug) System.out.println("Liste de mots inutiles:: "+laChaineLue);
        int i=0;
        while(i<s.size()){
            if (inStrLev((String)s.elementAt(i),laChaineLue)==0){
                s.remove(i);
            } else{i++;}
        }
        in.close();
        return s;
    }
}
