/*
 * SQL.java
 *
 * Created on 2 dcembre 2004, 18:02
 */

package metacalendrier;
import java.util.*;
import java.sql.*;

/**
 * This class handles MySQL connection, interact with other parts
 * via Event object.
 * @author  Hai Nam
 */
public class SQL {
    
    protected String user = "p48";
    protected String pass = "riencci";
    protected String url = "jdbc:mysql://hainam.maisel.enst-bretagne.fr:3306/p48";
    
    public static final String CONNECTION_NAME = "com.mysql.jdbc.Driver";
    public static final String tblEvents = "events";
    public static final String tblRawEvents = "events_raw";
    
    private Connection conn;
    private Statement stmt;
    
    /** Crer une nouvelle connexion MySQL */
    public SQL() {
        try {
            Class.forName(CONNECTION_NAME).newInstance();   // s'inscrire le pilote
            conn = DriverManager.getConnection(url, user, pass);
            stmt = conn.createStatement();
        } catch( Exception e ) {
            e.printStackTrace();
        }
    }
    
    /** Fermer la connexion MySQL */
    protected void finalize(){
        try{
            conn.close();
        } catch( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    public Connection getConn(){
        return conn;
    }
    
    /**
     * Insrer un nouveau vnement initial
     * avec tous attributs, pour le "Refiner" aprs
     * @param e vnement
     */
    public void insertRawEvent(Event e){
        java.sql.Date dateBegin, dateEnd;
        dateBegin = new java.sql.Date(e.getDateBegin().getTime());
        dateEnd = new java.sql.Date(e.getDateEnd().getTime());
        try{
            PreparedStatement prep = conn.prepareStatement("INSERT INTO "+tblRawEvents+"(url, timeWrap, dateBegin, dateEnd, place, country, title, detail) VALUES (?,?,?,?,?,?,?,?)");
            prep.setString(1, e.getUrl());
            prep.setInt(2, (int)e.getTimeWrap().getTime()/1000);
            prep.setDate(3, dateBegin);
            prep.setDate(4, dateEnd);
            prep.setString(5, e.getPlace());
            prep.setString(6, e.getCountry());
            prep.setString(7, e.getTitle());
            prep.setString(8, e.getDetail());
            prep.executeUpdate();
        } catch( Exception ex ) {
            ex.printStackTrace();
        }
    
    }
    
    /**
     *Insrer un vnement dans la BDD
     *@param e vnement
     */
    public void insertEvent(Event e){
        java.sql.Date dateBegin, dateEnd;
        dateBegin = new java.sql.Date(e.getDateBegin().getTime());
        dateEnd = new java.sql.Date(e.getDateEnd().getTime());
        try{
            PreparedStatement prep = conn.prepareStatement("INSERT INTO "+tblEvents+"(id, dateBegin, dateEnd, place, country, title, detail) VALUES (?,?,?,?,?,?,?)");
            prep.setInt(1, e.getId());
            prep.setDate(2, dateBegin);
            prep.setDate(3, dateEnd);
            prep.setString(4, e.getPlace());
            prep.setString(5, e.getCountry());
            prep.setString(6, e.getTitle());
            prep.setString(7, e.getDetail());
            prep.executeUpdate();
        } catch( Exception ex ) {
            ex.printStackTrace();
        }
    }
    
    /**
     * Lire un vnement initial
     *
     * @param id  ID d'vnement
     * @return null ou un vnement
     */
    public Object getRawEvent(int id){
        ResultSet rs=null;
        Event e = null;
        try{
            rs = stmt.executeQuery(
                "SELECT * " +
                "FROM " + tblRawEvents + " " +
                "WHERE id = " + id
            );
            if (rs.next()) {
                e = readEvent(rs);
            }
        } catch( Exception ex ){
            ex.printStackTrace();
        }
        return e;
    }
    
    /**
     * Convertir un objet ResultSet en objet Event
     */
    public Event readEvent(ResultSet rs){
        Event e = null;
        try{
            e = new Event(
                rs.getInt("id"), 
                rs.getString("url"), 
                rs.getDate("timeWrap"), 
                rs.getDate("dateBegin"), 
                rs.getDate("dateEnd"), 
                rs.getString("place"), 
                rs.getString("country"), 
                rs.getString("title"), 
                rs.getString("detail"));
        } catch( Exception ex ){
            System.out.println("EXCEPTION: "+ex);
        }
        return e;
    }
    /**
     * Excuter un rqute SQL
     */
    public ResultSet query(String query){
        ResultSet rs=null;
        try{
            rs = stmt.executeQuery(query);
        } catch( Exception ex ){
            System.out.println("EXCEPTION: "+ex);
        }
        return rs;
    }
}
