/*
 * Created on 2 nov
 *
 */
package metacalendrier.util;

import java.lang.*;
import java.util.*;
import java.text.SimpleDateFormat;
import org.xml.sax.*;
import org.xml.sax.helpers.LocatorImpl;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLFilterImpl ;
import metacalendrier.Event;

/**
 * Exemple d'implementation d'un SAX XML ContentHandler pour le site acm.org
 * <br />_bug_ Les 2 derniers elements de "maliste" sont le mme!
 *
 * @author said
 */
public class SimpleContentHandler implements ContentHandler {
    
    private String currentQName;
    private Attributes currentAttributes;
    public static ArrayList list = new ArrayList();
    private  String titre;
    private  String dateDebut;
    private  String dateFin;
    private  String lieu;
    private  String detail;
    private boolean booleanAjout;
    /**
     * Constructeur par defaut.
     */
    public SimpleContentHandler() {
        super();
        // On definit le locator par defaut.
        
        locator = new LocatorImpl();
    }
    
    /**
     * Definition du locator qui permet a tout moment pendant l'analyse, de localiser
     * le traitement dans le flux. Le locator par defaut indique, par exemple, le numero
     * de ligne et le numero de caractere sur la ligne.
     * @param value le locator a utiliser.
     */
    public void setDocumentLocator(Locator value) {
        locator =  value;
    }
    
    
    /**
     * Evenement envoye au demarrage du parse du flux xml.
     * @throws SAXException en cas de probleme quelquonque ne permettant pas de
     * se lancer dans l'analyse du document.
     */
    public void startDocument() throws SAXException {
        System.out.println("Debut de l'analyse du document");
    }
    
    /**
     * Evenement envoye a la fin de l'analyse du flux xml.
     * @throws SAXException en cas de probleme quelquonque ne permettant pas de
     * considerer l'analyse du document comme etant complete.
     */
    public void endDocument() throws SAXException {
        System.out.println("Fin de l'analyse du document" );
    }
    
    /**
     * Debut de traitement dans un espace de nommage.
     * @param prefix utilise pour cet espace de nommage dans cette partie de l'arborescence.
     * @param URI de l'espace de nommage.
     */
    public void startPrefixMapping(String prefix, String URI) throws SAXException {
    }
    
    /**
     * Fin de traitement de l'espace de nommage.
     * @param prefix le prefixe choisi a l'ouverture du traitement de l'espace nommage.
     */
    public void endPrefixMapping(String prefix) throws SAXException {
    }
    
    /**
     * Evenement recu a chaque fois que l'analyseur rencontre une balise xml ouvrante.
     * @param nameSpaceURI l'url de l'espace de nommage.
     * @param localName le nom local de la balise.
     * @param rawName nom de la balise en version 1.0 <code>nameSpaceURI + ":" + localName</code>
     * @throws SAXException si la balise ne correspond pas a ce qui est attendu,
     * comme par exemple non respect d'une dtd.
     */
    public void startElement(String nameSpaceURI, String localName, String rawName, Attributes attributs) throws SAXException {
        currentQName = rawName;
        currentAttributes = attributs;
        if("and".equals(rawName)){//initialisation de l'objet event.
            dateDebut = "";
            dateFin = "";
            titre = " ";
            lieu = " ";
            detail = " ";
        }
        
    }
    
    /**
     * Evenement recu a chaque fois que l'analyseur rencontre des caracteres (entre
     * deux balises).
     * @param ch les caracteres proprement dits.
     * @param start le rang du premier caractere a traiter effectivement.
     * @param end le rang du dernier caractere a traiter effectivement
     */
    public void characters(char[] ch, int start, int end) throws SAXException {
        
        
        if("attribute".equals(currentQName) && "Date".equals(currentAttributes.getValue(0))){
            String string = new String(ch, start, end);
            string=string.trim();//enlever les espaces
            if (string.length() > 0){
                String[] dates = Traitement.traiteDate(string);//[anneeDeb,moisDeb,jourDeb,anneeFin,moisFin,jourFin]
                if(dates[4].compareTo(dates[1])<0){//si le mois de la fin est inferieur au debut =>changer annee.
                    dates[3]="2005";//anneeFin=anneeDebut+1
                } else {dates[3]=dates[0];}
                dateDebut=dates[0]+"-"+dates[1]+"-"+dates[2];
                dateFin=dates[3]+"-"+dates[4]+"-"+dates[5];
            }//fin traitement du string date.
        }
        
        if("link".equals(currentQName)){
            String target = currentAttributes.getValue(0);
            detail=target;
            //System.out.println("detail : " + event.detail);
        }
        
        
        if("attribute".equals(currentQName) && "Title".equals(currentAttributes.getValue(0))){
            String string = (new String(ch, start, end)).trim();
            if (string.length() > 0)
                titre+=string;
            // System.out.println("titre : " + event.titre+"\n");
        }
        if("attribute".equals(currentQName) && "Place".equals(currentAttributes.getValue(0))){
            String string = (new String(ch, start, end)).trim();
            if (string.length() > 0) {
                lieu +=" "+string;
                booleanAjout=true;
                //System.out.println("lieu : " + event.lieu);
            }
            
        }
        
    }
    
    /**
     * Evenement recu a chaque fermeture de balise.
     */
    public void endElement(String nameSpaceURI, String localName, String rawName) throws SAXException {
        if("and".equals(rawName)){
            //je verifie si j'ai deja ajout mon objet dans la liste
            //si oui=>booleanAjout=false, sinon(booleanAjout=true) je l'ajoute!
            //parce qu'il se peut qu'il y ait deux noeuds successifs <and> sans qu'il y ait des balises
            //<attribute> entre elles.
            try {
                SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
                Event event = new Event(0, detail, new Date(), df.parse(dateDebut), df.parse(dateFin), lieu, "", titre, detail);
                if (event != null)
                {
                    list.add(event); //insertion dans la liste des objets.
                    booleanAjout = false;
                }
            } catch (Exception e) {
                System.out.println("Exception : "+e);
            }
        }
    }
    
    
    
    /**
     * Recu chaque fois que des caracteres d'espacement peuvent etre ignores au sens de
     * XML. C'est a dire que cet evenement est envoye pour plusieurs espaces se succedant,
     * les tabulations, et les retours chariot se succedants ainsi que toute combinaison de ces
     * trois types d'occurrence.
     * @param ch les caracteres proprement dits.
     * @param start le rang du premier caractere a traiter effectivement.
     * @param end le rang du dernier caractere a traiter effectivement
     */
    public void ignorableWhitespace(char[] ch, int start, int end) throws SAXException {
    }
    
    /**
     * Rencontre une instruction de fonctionnement.
     * @param target la cible de l'instruction de fonctionnement.
     * @param data les valeurs associees a cette cible. En general, elle se presente sous la forme
     * d'une serie de paires nom/valeur.
     */
    public void processingInstruction(String target, String data) throws SAXException {
    }
    
    /**
     * Recu a chaque fois qu'une balise est evitee dans le traitement a cause d'un
     * probleme non bloque par le parser.
     */
    public void skippedEntity(String arg0) throws SAXException {
    }
    
    private Locator locator;
    
    
}