package metacalendrier.util;

import java.lang.*;
import java.util.*;
import metacalendrier.*;

/**
 * Traitement de date, utilis dans le parser XML
 * @author said
 * @version 1.0
 */

public class Traitement {
    /**
     *Constructeur nul.
     */
    public Traitement() {
        
    }
    
    /**
     * methode qui demande une chaine de caractere et qui donne en sortie
     * un tableau de String de la forme :
     * [anneeDebut,moisDebut,jourDebut,anneeFin,moisFin,jourFin]
     */
    
    public static String[] traiteDate(String string){
        String[] dates = new String[6]; //tableau dates [anneeDeb,moisDeb,jourDeb,anneeFin,moisFin,jourFin]
        String[] table = string.split("-");
        if (table.length == 2) { //le tableau doit contenir deux fragments seulement
            
            String[] debut = table[0].split(" ");
            dates[1] = changeMonth(debut[0]); //deuxieme case du tableau dates correspondant au mois dateDebut.
            dates[2] = getJour(debut[1]); //inscription jour debut
            if (table[1].length() < 5) { //si la deuxieme date ne contient pas le mois(=>length<5)!!
                dates[4] = dates[1];
                dates[5] = getJour(table[1]); //inscription jour fin.
            } else {
                String[] fin = table[1].split(" ", 2);
                dates[4] = changeMonth(fin[0]); //4eme case du tableau dates correspondant au mois dateFin.
                dates[5] = getJour(fin[1]); //inscription jour fin.
            }
        } else {
            for (int i = 1; i < 6; i++) {
                dates[i] = "00";
            }
        }
        dates[0] = "2004";
        return dates;
    }
    
    
    /**
     * methode qui remplace un mois en texte,par un mois en chiffres.
     */
    
    public static String changeMonth(String s){
        if ("January".equals(s))
            return "01";
        if ("February".equals(s))
            return "02";
        if ("March".equals(s))
            return "03";
        if ("April".equals(s))
            return "04";
        if ("may".equals(s))
            return "05";
        if ("June".equals(s))
            return "06";
        if ("July".equals(s))
            return "07";
        if ("August".equals(s))
            return "08";
        if ("September".equals(s))
            return "09";
        if ("October".equals(s))
            return "10";
        if ("November".equals(s))
            return "11";
        if ("December".equals(s))
            return "12";
        else return " ";
    }
    
    /**
     * methode qui demande une chaine de caractere de la forme "31st   " (ou de la forme
     * "3rd   ") et qui rend le string "31" (ou "01").
     */
    
    
    public static String getJour(String s){
        String jour=s.substring(0,2);
        if(jour.endsWith("t") || jour.endsWith("s") || jour.endsWith("n") || jour.endsWith("r"))
            return "0"+jour.substring(0,1);
        else return jour;
    }
}